"use strict";

require("core-js/modules/es.symbol");

require("core-js/modules/es.symbol.description");

require("core-js/modules/es.symbol.iterator");

require("core-js/modules/es.array.concat");

require("core-js/modules/es.array.filter");

require("core-js/modules/es.array.for-each");

require("core-js/modules/es.array.from");

require("core-js/modules/es.array.is-array");

require("core-js/modules/es.array.iterator");

require("core-js/modules/es.date.to-string");

require("core-js/modules/es.object.define-properties");

require("core-js/modules/es.object.define-property");

require("core-js/modules/es.object.get-own-property-descriptor");

require("core-js/modules/es.object.get-own-property-descriptors");

require("core-js/modules/es.object.keys");

require("core-js/modules/es.object.to-string");

require("core-js/modules/es.regexp.to-string");

require("core-js/modules/es.string.iterator");

require("core-js/modules/web.dom-collections.for-each");

require("core-js/modules/web.dom-collections.iterator");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _graphql = require("graphql");

var _execa = _interopRequireDefault(require("execa"));

var _emptyFunction = _interopRequireDefault(require("fbjs/lib/emptyFunction"));

var _mockChoice = _interopRequireDefault(require("@mikojs/utils/lib/mockChoice"));

var _buildSchema = _interopRequireDefault(require("./utils/buildSchema"));

var _updateSchema = _interopRequireDefault(require("./utils/updateSchema"));

var _buildMiddleware = _interopRequireDefault(require("./utils/buildMiddleware"));

var _getSchemaFilePath = _interopRequireDefault(require("./utils/getSchemaFilePath"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance"); }

function _iterableToArray(iter) { if (Symbol.iterator in Object(iter) || Object.prototype.toString.call(iter) === "[object Arguments]") return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = new Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } }

/**
 * @example
 * graphql('/folderPath')
 *
 * @param {string} folderPath - the folder path
 * @param {optionsType} options - koa graphql options
 *
 * @return {returnType} - koa graphql functions
 */
var _default = function _default(folderPath) {
  var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
  var schema = (0, _buildSchema["default"])(folderPath, options);
  return {
    // update
    update: function update(filePath) {
      return (0, _updateSchema["default"])(folderPath, options, schema, filePath);
    },
    // middleware
    middleware: function middleware(graphqlOptions) {
      return (0, _buildMiddleware["default"])(schema, graphqlOptions);
    },
    // run relay-compiler
    runRelayCompiler: function runRelayCompiler(argv) {
      return (0, _mockChoice["default"])(process.env.NODE_ENV === 'test', _emptyFunction["default"], _execa["default"])('relay-compiler', ['--schema', (0, _getSchemaFilePath["default"])(schema)].concat(_toConsumableArray(argv)), {
        stdio: 'inherit',
        preferLocal: true
      });
    },
    // query
    query: function query(graphQLArgs) {
      return (0, _graphql.graphql)(_objectSpread({}, graphQLArgs, {
        schema: schema
      }));
    }
  };
};

exports["default"] = _default;
module.exports = exports.default;