"use strict";

require("core-js/modules/es.symbol");

require("core-js/modules/es.symbol.description");

require("core-js/modules/es.symbol.iterator");

require("core-js/modules/es.array.concat");

require("core-js/modules/es.array.filter");

require("core-js/modules/es.array.for-each");

require("core-js/modules/es.array.from");

require("core-js/modules/es.array.index-of");

require("core-js/modules/es.array.is-array");

require("core-js/modules/es.array.iterator");

require("core-js/modules/es.array.reduce");

require("core-js/modules/es.date.to-string");

require("core-js/modules/es.object.define-properties");

require("core-js/modules/es.object.define-property");

require("core-js/modules/es.object.get-own-property-descriptor");

require("core-js/modules/es.object.get-own-property-descriptors");

require("core-js/modules/es.object.keys");

require("core-js/modules/es.object.to-string");

require("core-js/modules/es.regexp.to-string");

require("core-js/modules/es.string.iterator");

require("core-js/modules/web.dom-collections.for-each");

require("core-js/modules/web.dom-collections.iterator");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _graphqlTools = require("graphql-tools");

var _debug = _interopRequireDefault(require("debug"));

var _d3DirTree = _interopRequireDefault(require("@mikojs/utils/lib/d3DirTree"));

var _requireModule2 = _interopRequireDefault(require("@mikojs/utils/lib/requireModule"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance"); }

function _iterableToArray(iter) { if (Symbol.iterator in Object(iter) || Object.prototype.toString.call(iter) === "[object Arguments]") return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = new Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var debugLog = (0, _debug["default"])('graphql:buildSchema');
/**
 * @example
 * buildSchema('/folderPath', {})
 *
 * @param {string} folderPath - folder path
 * @param {optionsType} options - koa graphql options
 *
 * @return {GraphQLSchemaType} - graphql schema
 */

var _default = function _default(folderPath, _ref) {
  var _ref$extensions = _ref.extensions,
      extensions = _ref$extensions === void 0 ? /\.js$/ : _ref$extensions,
      exclude = _ref.exclude,
      _ref$makeExecutableSc = _ref.makeExecutableSchemaOptions;
  _ref$makeExecutableSc = _ref$makeExecutableSc === void 0 ? {} : _ref$makeExecutableSc;

  var additionalTypeDefs = _ref$makeExecutableSc.typeDefs,
      additionalResolvers = _ref$makeExecutableSc.resolvers,
      resolverValidationOptions = _ref$makeExecutableSc.resolverValidationOptions,
      options = _objectWithoutProperties(_ref$makeExecutableSc, ["typeDefs", "resolvers", "resolverValidationOptions"]);

  var _d3DirTree$leaves$red = (0, _d3DirTree["default"])(folderPath, {
    extensions: extensions,
    exclude: exclude
  }).leaves().reduce(function (result, _ref2) {
    var filePath = _ref2.data.path;

    var _requireModule = (0, _requireModule2["default"])(filePath),
        newTypeDefs = _requireModule.typeDefs,
        newResolvers = _objectWithoutProperties(_requireModule, ["typeDefs"]);

    return {
      typeDefs: [].concat(_toConsumableArray(result.typeDefs), [newTypeDefs]),
      resolvers: Object.keys(newResolvers).reduce(function (prevResolvers, resolverName) {
        return _objectSpread({}, prevResolvers, _defineProperty({}, resolverName, _objectSpread({}, prevResolvers[resolverName], {}, newResolvers[resolverName])));
      }, result.resolvers)
    };
  }, {
    typeDefs: additionalTypeDefs instanceof Array || !additionalTypeDefs ? additionalTypeDefs || [] : [additionalTypeDefs],
    resolvers: additionalResolvers || {}
  }),
      typeDefs = _d3DirTree$leaves$red.typeDefs,
      resolvers = _d3DirTree$leaves$red.resolvers;

  debugLog({
    typeDefs: typeDefs,
    resolvers: resolvers
  });
  return (0, _graphqlTools.makeExecutableSchema)(_objectSpread({}, options, {
    resolverValidationOptions: _objectSpread({}, resolverValidationOptions, {
      requireResolversForResolveType: false
    }),
    typeDefs: typeDefs,
    resolvers: resolvers
  }));
};

exports["default"] = _default;
module.exports = exports.default;