"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _path = _interopRequireDefault(require("path"));

var _graphql = require("graphql");

var _findCacheDir = _interopRequireDefault(require("find-cache-dir"));

var _outputFileSync = _interopRequireDefault(require("output-file-sync"));

var _debug = _interopRequireDefault(require("debug"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

var debugLog = (0, _debug["default"])('graphql:getSchemaFilePath');
/**
 * @example
 * getSchemaFilePath(schema)
 *
 * @param {GraphQLSchemaType} schema - built schema
 *
 * @return {string} - schema file path
 */

var _default = function _default(schema) {
  var schemaFilePath = _path["default"].resolve((0, _findCacheDir["default"])({
    name: 'koa-graphql'
  }), './schema.graphql');

  debugLog(schemaFilePath);
  (0, _outputFileSync["default"])(schemaFilePath, (0, _graphql.printSchema)(schema));
  return schemaFilePath;
};

exports["default"] = _default;
module.exports = exports.default;