"use strict";

require("core-js/modules/es.symbol");

require("core-js/modules/es.array.filter");

require("core-js/modules/es.array.for-each");

require("core-js/modules/es.object.define-properties");

require("core-js/modules/es.object.define-property");

require("core-js/modules/es.object.get-own-property-descriptor");

require("core-js/modules/es.object.get-own-property-descriptors");

require("core-js/modules/es.object.keys");

require("core-js/modules/es.regexp.constructor");

require("core-js/modules/es.regexp.exec");

require("core-js/modules/es.regexp.to-string");

require("core-js/modules/web.dom-collections.for-each");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _path = _interopRequireDefault(require("path"));

var _graphqlTools = require("graphql-tools");

var _debug = _interopRequireDefault(require("debug"));

var _requireModule = _interopRequireDefault(require("@mikojs/utils/lib/requireModule"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var debugLog = (0, _debug["default"])('graphql:updateSchema');
/**
 * @example
 * updateSchema('/folderPath', {}, schema, '/filePath')
 *
 * @param {string} folderPath - the folder path
 * @param {optionsType} options - koa graphql options
 * @param {GraphQLSchemaType} schema - built schema
 * @param {string} filePath - the file path
 */

var _default = function _default(folderPath, _ref, schema, filePath) {
  var _ref$extensions = _ref.extensions,
      extensions = _ref$extensions === void 0 ? /\.js$/ : _ref$extensions,
      exclude = _ref.exclude,
      _ref$makeExecutableSc = _ref.makeExecutableSchemaOptions;
  _ref$makeExecutableSc = _ref$makeExecutableSc === void 0 ? {} : _ref$makeExecutableSc;
  var resolverValidationOptions = _ref$makeExecutableSc.resolverValidationOptions;
  if (!filePath || !extensions.test(filePath) || (exclude === null || exclude === void 0 ? void 0 : exclude.test(filePath)) || !new RegExp(_path["default"].resolve(folderPath)).test(filePath)) return;
  var newResolvers = (0, _requireModule["default"])(filePath);
  debugLog(newResolvers);
  delete newResolvers.typeDefs;
  if (Object.keys(newResolvers).length === 0) return;
  (0, _graphqlTools.addResolveFunctionsToSchema)({
    schema: schema,
    resolvers: newResolvers,
    resolverValidationOptions: _objectSpread({}, resolverValidationOptions, {
      requireResolversForResolveType: false
    }),
    inheritResolversFromInterfaces: true
  });
};

exports["default"] = _default;
module.exports = exports.default;